# Sid Meier's Civilization 4
# Copyright Firaxis Games 2007
# MININGEvents
# MINING Mod By cripp
# Modular python project to eliminate or reduce merging tasks
from CvPythonExtensions import *
import CvUtil
import CvDebugTools


# globals
gc = CyGlobalContext()


class MiningEvents:
	def __init__(self, eventMgr):
# ###############################################################################
#		Important!!!!															#
#		Each function added from CvEventManager.py must be initialized here 	#
# ###############################################################################
		self.__LOG_IMPROVEMENT =0
		self.eventMgr = eventMgr
		
		eventMgr.addEventHandler("improvementBuilt", self.onImprovementBuilt)
	
	def onImprovementBuilt(self, argsList):
		# Mining Mod
		# Purpose: Places a mining bonus on plot upon worker
		# completion of an improvement (GOLD, GEMS or SILVER)
		'Improvement Built'
		iImprovement, iX, iY = argsList
		iPlayerID = gc.getPlayer(CyGame().getActivePlayer()).getID()			
		player = gc.getPlayer(iPlayerID)	
		
		if (iImprovement == gc.getInfoTypeForString('IMPROVEMENT_GOLD')) :
			pPlot = CyMap().plot(iX, iY)
			pPlot.setImprovementType(-1)
			pPlot.setBonusType(gc.getInfoTypeForString("BONUS_GOLD"))			
			
			if (player.isAlive() and player.isHuman()):
				CyInterface().addMessage(CyGame().getActivePlayer(),True,25,'A GOLD Mine was Created!','AS2D_DISCOVERBONUS',1,'Art/Interface/Buttons/general/happy_person.dds',ColorTypes(8),iX,iY,False,False)

		if (iImprovement == gc.getInfoTypeForString('IMPROVEMENT_GEMS')) :
			pPlot = CyMap().plot(iX, iY)
			pPlot.setImprovementType(0)
			pPlot.setBonusType(gc.getInfoTypeForString("BONUS_GEMS"))
			
			if (player.isAlive() and player.isHuman()):
				CyInterface().addMessage(CyGame().getActivePlayer(),True,25,'A GEMS Mine was Created!','AS2D_DISCOVERBONUS',1,'Art/Interface/Buttons/general/happy_person.dds',ColorTypes(8),iX,iY,False,False)

		if (iImprovement == gc.getInfoTypeForString('IMPROVEMENT_SILVER')) :
			pPlot = CyMap().plot(iX, iY)
			pPlot.setImprovementType(0)
			pPlot.setBonusType(gc.getInfoTypeForString("BONUS_SILVER"))
			
			if (player.isAlive() and player.isHuman()):
				CyInterface().addMessage(CyGame().getActivePlayer(),True,25,'A SILVER Mine was Created!','AS2D_DISCOVERBONUS',1,'Art/Interface/Buttons/general/happy_person.dds',ColorTypes(8),iX,iY,False,False)
		
		if (not self.__LOG_IMPROVEMENT):
			return
		CvUtil.pyPrint('Improvement %s was built at %d, %d'
			%(PyInfo.ImprovementInfo(iImprovement).getDescription(), iX, iY))
# End MINING Mod
		
		
	